package dev.shadowsoffire.apotheosis.adventure.affix.reforging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingRecipe;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTile;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.cap.InternalItemHandler;
import dev.shadowsoffire.placebo.menu.BlockEntityMenu;
import dev.shadowsoffire.placebo.menu.PlaceboContainerMenu;
import java.util.Objects;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.util.RandomSource;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.DataSlot;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.levelgen.XoroshiroRandomSource;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.wrapper.RecipeWrapper;
import net.minecraftforge.registries.ForgeRegistries;

public class ReforgingMenu extends BlockEntityMenu<ReforgingTableTile> {
  public static final String REFORGE_SEED = "apoth_reforge_seed";
  
  protected final Player player;
  
  protected InternalItemHandler itemInv = new InternalItemHandler(1);
  
  protected InternalItemHandler choicesInv = new InternalItemHandler(3);
  
  protected final RandomSource random = (RandomSource)new XoroshiroRandomSource(0L);
  
  protected final int[] costs = new int[3];
  
  protected int seed = -1;
  
  public ReforgingMenu(int id, Inventory inv, BlockPos pos) {
    super((MenuType)Adventure.Menus.REFORGING.get(), id, inv, pos);
    this.player = inv.f_35978_;
    m_38897_((Slot)new Object(this, this.itemInv, 0, 81, 62, stack -> !LootCategory.forItem(stack).isNone()));
    Objects.requireNonNull((ReforgingTableTile)this.tile);
    m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot((PlaceboContainerMenu)this, ((ReforgingTableTile)this.tile).inv, 0, 39, 40, (ReforgingTableTile)this.tile::isValidRarityMat));
    m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot((PlaceboContainerMenu)this, ((ReforgingTableTile)this.tile).inv, 1, 123, 86, stack -> (stack.m_41720_() == Adventure.Items.SIGIL_OF_REBIRTH.get())));
    m_38897_((Slot)new ReforgingResultSlot(this, (IItemHandler)this.choicesInv, 0, 27, 135));
    m_38897_((Slot)new ReforgingResultSlot(this, (IItemHandler)this.choicesInv, 1, 81, 135));
    m_38897_((Slot)new ReforgingResultSlot(this, (IItemHandler)this.choicesInv, 2, 135, 135));
    addPlayerSlots(inv, 8, 184);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && !LootCategory.forItem(stack).isNone()), 0, 1);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && ((ReforgingTableTile)this.tile).isValidRarityMat(stack)), 1, 2);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && stack.m_41720_() == Adventure.Items.SIGIL_OF_REBIRTH.get()), 2, 3);
    this.mover.registerRule((stack, slot) -> (slot.intValue() < this.playerInvStart), this.playerInvStart, this.hotbarStart + 9);
    registerInvShuffleRules();
    updateSeed();
    m_38895_(DataSlot.m_39406_(this.costs, 0));
    m_38895_(DataSlot.m_39406_(this.costs, 1));
    m_38895_(DataSlot.m_39406_(this.costs, 2));
  }
  
  public void m_6877_(Player pPlayer) {
    super.m_6877_(pPlayer);
    m_150411_(pPlayer, (Container)new RecipeWrapper((IItemHandlerModifiable)this.itemInv));
  }
  
  protected void updateSeed() {
    int seed = this.player.getPersistentData().m_128451_("apoth_reforge_seed");
    if (seed == 0) {
      seed = this.player.f_19796_.m_188502_();
      this.player.getPersistentData().m_128405_("apoth_reforge_seed", seed);
    } 
    this.seed = seed;
  }
  
  public int getMatCount() {
    return m_38853_(1).m_7993_().m_41613_();
  }
  
  public int getSigilCount() {
    return m_38853_(2).m_7993_().m_41613_();
  }
  
  @Nullable
  public LootRarity getRarity() {
    ItemStack s = m_38853_(1).m_7993_();
    if (s.m_41619_())
      return null; 
    return RarityRegistry.getMaterialRarity(s.m_41720_()).getOptional().orElse(null);
  }
  
  public int getSigilCost(int slot) {
    return this.costs[0] * ++slot;
  }
  
  public int getMatCost(int slot) {
    return this.costs[1] * ++slot;
  }
  
  public int getLevelCost(int slot) {
    return this.costs[2] * ++slot;
  }
  
  public void m_6199_(Container pContainer) {
    LootRarity rarity = getRarity();
    if (rarity != null) {
      ReforgingRecipe recipe = ((ReforgingTableTile)this.tile).getRecipeFor(rarity);
      if (recipe != null) {
        this.costs[0] = recipe.sigilCost();
        this.costs[1] = recipe.matCost();
        this.costs[2] = recipe.levelCost();
      } 
    } 
    ItemStack input = m_38853_(0).m_7993_();
    for (int slot = 0; slot < 3; slot++) {
      if (!input.m_41619_() && rarity != null) {
        RandomSource rand = this.random;
        rand.m_188584_((this.seed ^ ForgeRegistries.ITEMS.getKey(input.m_41720_()).hashCode() + slot));
        ItemStack output = LootController.createLootItem(input.m_41777_(), rarity, rand);
        this.choicesInv.setStackInSlot(slot, output);
      } else {
        this.choicesInv.setStackInSlot(slot, ItemStack.f_41583_);
      } 
    } 
    super.m_6199_(pContainer);
    ((ReforgingTableTile)this.tile).m_6596_();
  }
}
